﻿// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "AIController.h"
#include "AI_CompanionController.generated.h"

struct FAIStimulus;

UCLASS()
class ENDLESSVENDETTA_API AAI_CompanionController : public AAIController
{
	GENERATED_BODY()

public:
	// Sets default values for this actor's properties
	explicit AAI_CompanionController(FObjectInitializer const& ObjectInitializer);

protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;
	virtual void OnPossess(APawn* InPawn) override;

public:
	// Called every frame
	virtual void Tick(float DeltaTime) override;

private:
	class UAISenseConfig_Sight* SightConfig;
	void SetupPerceptionSystem();

	UFUNCTION()
	void OnTargetPerceptionUpdated(AActor* Actor, FAIStimulus const Stimulus);

};
